
#ifndef   	V_3D_H_
# define   	V_3D_H_

#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>
using namespace std;

class V_3D
{
 public:
  V_3D();
  V_3D(const V_3D &v_3D);
  V_3D(double x,double y,double z);
  ~V_3D();


  int set(double *v);
  int set(int k_dim,double value);
  int set(V_3D _V);
  int set(double x,double y,double z);

  double get(int k_dim) const;
  int get(double *v) const;
  V_3D get() const;
  double *get_pointer();

  double dot(V_3D _v) const;
  V_3D vector_prod(V_3D _v) const;
  double norm() const;
  double area(V_3D _v) const;

  V_3D get_min_scalar(const V_3D& _v) const;
  V_3D get_max_scalar(const V_3D& _v) const;
  double get_max_of_coeff() const;
  double get_min_of_coeff() const;


  V_3D& operator=(const V_3D&);
  V_3D& operator+=(const V_3D&);
  V_3D& operator/=(const double&);
  friend V_3D operator+(const V_3D& v1,const V_3D& v2);
  friend V_3D operator-(const V_3D& v1,const V_3D& v2);
  friend V_3D operator*(const V_3D& v1,const double& alpha);
  friend V_3D operator*(const double& alpha,const V_3D& v1);
  friend V_3D operator/(const V_3D& v1,const double& alpha);
  friend int operator==(const V_3D& v1,const V_3D& v2);
  friend int operator!=(const V_3D& v1,const V_3D& v2);

  double& operator[](int index);
  double operator[](int index) const;

  friend ostream& operator << (ostream& flux, V_3D _v);

 private:

  double V[3];
};


#endif 	    /* !V_3D_H_ */
