
#include <Curve_3D.h>

Curve_3D::Curve_3D()
{
}

Curve_3D::~Curve_3D()
{
  destroy();
}

Curve_3D::Curve_3D(const Curve_3D& _curve)
{
  int N_points=_curve.size();
  data.resize(N_points);
  for(int k=0;k<N_points;k++)
    data[k] = _curve.data[k];
}

int Curve_3D::destroy()
{data.resize(0);return 0;}

int Curve_3D::size() const
{return data.size();}

int Curve_3D::add_point(const V_3D& point)
{data.push_back(point);return 0;}

V_3D& Curve_3D::get(int k_index)
{
  if(k_index<0 || k_index>=size())
    {printf("Error k_index [%d] not in bounds in get in Curve_3D\n",k_index);exit(-1);}
  return data[k_index];
}
V_3D Curve_3D::get(int k_index) const
{
  if(k_index<0 || k_index>=size())
    {printf("Error k_index [%d] not in bounds in get in Curve_3D\n",k_index);exit(-1);}
  return data[k_index];
}
V_3D& Curve_3D::operator[](int k_index)
{
  if(k_index<0 || k_index>=size())
    {printf("Error k_index [%d] not in bounds in operator[] in Curve_3D\n",k_index);exit(-1);}
  return data[k_index];
}
V_3D  Curve_3D::operator[](int k_index) const
{
  if(k_index<0 || k_index>=size())
    {printf("Error k_index [%d] not in bounds in operator[] in Curve_3D\n",k_index);exit(-1);}
  return data[k_index];
}
  
Curve_3D& Curve_3D::operator=(const Curve_3D& _curve)
{
  int N_points=_curve.size();
  data.resize(N_points);
  for(int k=0;k<N_points;k++)
    data[k] = _curve.data[k];
  return *this;
}

